﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SampleData;
using Infragistics.Web.Mvc;

namespace igGrid_AutoFormatModel.Controllers
{
	public class HomeController : Controller
	{
		public ActionResult Index()
		{
			MyViewModel vm = new MyViewModel();
			vm.grid1 = this.GetGridModel();
			vm.grid2 = this.GetGridModel2();
			return View(vm);
		}

		public JsonResult GetData()
		{
			GridModel gridModel = GetGridModel();
			gridModel.DataSource = this.GetProducts().AsQueryable();
			return gridModel.GetData();
		}

		public JsonResult GetData2()
		{
			GridModel gridModel = GetGridModel2();
			gridModel.DataSource = this.GetProducts().AsQueryable();
			return gridModel.GetData();
		}

		private GridModel GetGridModel()
		{
			GridModel gridModel = new GridModel();
			gridModel.DataSourceUrl = Url.Action("GetData");
			gridModel.AutoGenerateColumns = false;
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "ProductID",
				HeaderText = "ProductID",
				DataType = "number"
			});
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "Name",
				HeaderText = "Name"
			});
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "ProductNumber",
				HeaderText = "ProductNumber"
			});
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "Date",
				HeaderText = "Date",
				DataType = "date"
			});
			gridModel.Features.Add(new GridPaging()
			{
				Type = OpType.Remote,
				PageSize = 5
			});
			gridModel.Features.Add(new GridSorting()
			{
				Type = OpType.Remote
			});
			gridModel.Features.Add(new GridFiltering()
			{
				Type = OpType.Remote
			});

			gridModel.AutoFormat = GridAutoFormat.Number;
			return gridModel;
		}

		private GridModel GetGridModel2()
		{
			GridModel gridModel = new GridModel();
			gridModel.DataSourceUrl = Url.Action("GetData2");
			gridModel.AutoGenerateColumns = false;
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "ProductID",
				HeaderText = "ProductID",
				DataType = "number"
			});
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "Name",
				HeaderText = "Name"
			});
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "ProductNumber",
				HeaderText = "ProductNumber"
			});
			gridModel.Columns.Add(new GridColumn()
			{
				Key = "Date",
				HeaderText = "Date",
				DataType = "date"
			});

			gridModel.AutoFormat = GridAutoFormat.DateAndNumber;
			return gridModel;
		}

		private List<Product> GetProducts()
		{
			List<Product> products = new List<Product>()
			{
				new Product() { ProductID = 1, Name = "Adjustable Race", ProductNumber = "AR-5381", Date = DateTime.Now },
				new Product() { ProductID = 2, Name = "Bearing Ball", ProductNumber = "BA-8327", Date = DateTime.Now },
				new Product() { ProductID = 3, Name = "BB Ball Bearing", ProductNumber = "BE-2349", Date = DateTime.Now },
				new Product() { ProductID = 4, Name = "Headset Ball Bearings", ProductNumber = "BE-2908", Date = DateTime.Now },
				new Product() { ProductID = 1316, Name = "Blade", ProductNumber = "BL-2036", Date = DateTime.Now },
				new Product() { ProductID = 1317, Name = "LL Crankarm", ProductNumber = "CA-5965", Date = DateTime.Now },
				new Product() { ProductID = 1318, Name = "ML Crankarm", ProductNumber = "CA-6738", Date = DateTime.Now },
				new Product() { ProductID = 1319, Name = "HL Crankarm", ProductNumber = "CA-7457", Date = DateTime.Now },
				new Product() { ProductID = 1320, Name = "Chainring Bolts", ProductNumber = "CB-2903", Date = DateTime.Now },
				new Product() { ProductID = 1321, Name = "Chainring Nut", ProductNumber = "CN-6137", Date = DateTime.Now }
			};

			return products;
		}

		public class MyViewModel
		{
			public GridModel grid1 { get; set; }
			public GridModel grid2 { get; set; }
		}

		public class Product
		{
			public int ProductID { get; set; }
			public string Name { get; set; }
			public string ProductNumber { get; set; }
			public DateTime Date { get; set; }
		}
	}
}